#include <SPI.h>
#include <Bounce.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>

const int DIMM = 2;
const int CLK= 3;
const int MOSIx=4;
int num=0;

//other
int led = 13;
int red1=22;
int green1=32;
int inputB=42;
int val=0;
int exercise=1;

Bounce bouncer = Bounce( inputB,50 );

// the setup routine runs once when you press reset:
void setup() {   
  
  //wireless
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
  Mirf.setRADDR((byte *)"serv1");
  Mirf.payload = sizeof(unsigned long);
  Mirf.config(); 
  
  //SPI 4 digit DISPLAY
  pinMode (DIMM, OUTPUT);
  pinMode(CLK, OUTPUT);
  pinMode(MOSIx, OUTPUT);
  //SPI.begin(); 
  //SPI.setBitOrder(LSBFIRST);
  
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT);  
  Serial.begin(9600);
  Serial3.begin(9600);
  
  for (int i=0; i<7; i++){ 
    pinMode(red1+i, OUTPUT);  
    pinMode(green1+i, OUTPUT); 
    pinMode(inputB+i, INPUT_PULLUP);
  }
  for (int i=0; i<7; i++){ 
    digitalWrite(green1+i, LOW);
    digitalWrite(red1+i, LOW);
  }
  
  pinMode(6, INPUT_PULLUP);
}

// the loop routine runs over and over again forever:
void loop() {
//  digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
//  delay(200);               // wait for a second
//  digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
//  delay(200);               // wait for a second

int incomingByte = 0; 
  
  if (Serial.available() > 0) {
    // read the incoming byte:
    incomingByte = Serial.read();
    //Serial.print("I received: ");
    //Serial.println(incomingByte, DEC);
    if (incomingByte==50){
      Serial.println("send serial to NANO");
      Serial3.write(49);
    }
  }
/*
int sensorVal = digitalRead(6);
if (sensorVal == LOW) { 
    Serial.println("send serial to NANO");
    Serial3.write(49);
  }*/

digitalWrite(led, HIGH);

/*
for (int i=0; i<7; i++){ 
  digitalWrite(green1+i, HIGH);
  delay(300);
  digitalWrite(green1+i, LOW);
  //delay(300);
  if (checkForChange()>0){i=0;}
  //checkForChange();
}
delay(2000);
for (int i=0; i<7; i++){ 
  digitalWrite(red1+i, HIGH);
  delay(300);
  digitalWrite(red1+i, LOW);
  //delay(300);
  if (checkForChange()>0){i=0;}
  //checkForChange();
}*/

digitalWrite(led, LOW);
//delay(2000);
//Serial.println("CYCLE");

//exercise up
if (checkButton(4)&&checkButton(2)){
  if(exercise>=1&&exercise<10)  exercise+=1;
  printDisp("l "+String(exercise));
  while(checkButton(2));//wait until depressed;
  Serial.println("afterwhile1 "+String(exercise));
  delay(150);
}

//exercises down
if (checkButton(4)&&checkButton(5)){
  if(exercise>1)  exercise-=1;
  printDisp("l "+String(exercise));
  while(checkButton(5));//wait until depressed
  Serial.println("afterwhile2 "+String(exercise));
  delay(150);
}

if (checkButton(4)&&checkButton(1)){
  executeEx(exercise);
}

if (checkButton(1)&&checkButton(2)){
  Serial.println("Sending...");
  sendWriless();
  delay(1500);
}

//////////////////////////////////////////

 /*if (num==9)num=0;
  num=num+1;
  send4digits(num);
  delay(100); 
  clearDisp();
  printDisp("l 1");
  delay(1000);
  clearDisp();
  printDisp("l 2");
  delay(1000); */
  
}

int checkForChange(){
  for (int i=0; i<7; i++){ 
    if (digitalRead(inputB+i)==0){Serial.println(inputB+i); return 1; }
  }
  return 0;
}

int checkInput(){
  for (int i=0; i<7; i++){ 
    if (digitalRead(inputB+i)==0){return i; }
  }
  return 9;  //no button pressed
}


boolean checkButton(int b){
  //bouncer = Bounce( inputB+b-1,5);
  //bouncer.update();
  //if(bouncer.read()==0) {return true;}
  if(digitalRead(inputB+b-1)==0) {return true;}
  else{return false;}
}
